<?php
/**
* 2014 KerAwen
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/AFL-3.0
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to contact@kerawen.com so we can send you a copy immediately.
*
* @author    KerAwen <contact@kerawen.com>
* @copyright 2014 KerAwen
* @license   http://opensource.org/licenses/AFL-3.0 Academic Free License (AFL 3.0)
*/


function getGiftCardData($cond, $value) {
    
    $context = Context::getContext();
    $now = date('Y-m-d H:i:s', time());
    
    $q = "
			SELECT
                cart_rule.reduction_amount AS amount,
                cart_rule.reduction_currency AS id_currency,
                cart_rule.date_to AS expiry,
                cart_rule.code AS barcode,
                cart_rule.date_from AS date_from,
                DATE_FORMAT(cart_rule.date_from,'%d/%m/%Y') AS date_from_fr,
                product_lang.name AS product_name,
                cart_rule_kerawen.id_product,
                cart_rule_kerawen.id_attribute AS id_product_attribute,
                cart_rule_kerawen.id_order,
                orders.id_cart,
                orders.id_shop,
                orders.id_lang,
                customization.id_customization,
                customer.firstname,
                customer.lastname,
                customer.email
			FROM " . _DB_PREFIX_ . "cart_rule_kerawen cart_rule_kerawen
			    
			INNER JOIN " . _DB_PREFIX_ . "cart_rule cart_rule
                ON cart_rule_kerawen.id_cart_rule = cart_rule.id_cart_rule
			    
			LEFT JOIN " . _DB_PREFIX_ . "orders orders
                ON cart_rule_kerawen.id_order = orders.id_order
			    
            LEFT JOIN " . _DB_PREFIX_ . "customer customer
                ON orders.id_customer = customer.id_customer
                
            LEFT JOIN " . _DB_PREFIX_ . "order_detail order_detail
                ON cart_rule_kerawen.id_order = order_detail.id_order
                AND cart_rule_kerawen.id_attribute = order_detail.product_attribute_id
                AND cart_rule_kerawen.id_order = order_detail.id_order
                
            LEFT JOIN  " . _DB_PREFIX_ . "product_lang product_lang
                ON cart_rule_kerawen.id_product = product_lang.id_product
                AND product_lang.id_shop = orders.id_shop
                AND product_lang.id_lang = orders.id_lang
                
            LEFT JOIN " . _DB_PREFIX_ . "customization customization
                ON customization.id_product = order_detail.product_id
                AND customization.id_product_attribute = order_detail.product_attribute_id
                AND customization.id_cart = orders.id_cart
                
            WHERE TRUE
                AND ('" . pSQL($now) . "' BETWEEN cart_rule.date_from AND cart_rule.date_to)
                AND cart_rule_kerawen.type = '" . pSQL(_KERAWEN_CR_GIFT_CARD_) . "'
		";
    
    if ($cond == 'id_customer') {
        $q .= " AND orders.id_customer = " . (int) $value;
    }
    
    if ($cond == 'code') {
        $q .= " AND cart_rule.code = '" . pSQL($value) . "'";
    }

    if ($cond == 'id_order') {
        $q .= " AND cart_rule_kerawen.id_order = " . (int) $value;
    }
    

    $giftcards = Db::getInstance()->executeS($q);
    if ($giftcards) {
        
        foreach ($giftcards as $key => $item) {
            $giftcards[$key]['custom'] = array();
            if ($giftcards[$key]["id_customization"]) {
                
                $q = "
		            SELECT
                        c_data.index AS cindex,
                        c_data.value AS cvalue,
                        c_field_lang.name AS cname,
                        c_field_kerawen.field_type AS ctype
		            FROM " . _DB_PREFIX_ . "customized_data c_data
                    
		            LEFT JOIN " . _DB_PREFIX_ . "customization_field_lang c_field_lang
                        ON c_data.index = c_field_lang.id_customization_field
                        AND c_field_lang.id_shop = " . (int) $giftcards[$key]["id_shop"] . "
                        AND c_field_lang.id_lang = " . (int) $giftcards[$key]["id_lang"] . "
                            
		            LEFT JOIN " . _DB_PREFIX_ . "customization_field_kerawen c_field_kerawen
                        ON c_data.index = c_field_kerawen.id_customization_field
                            
		            WHERE c_data.id_customization = " . (int) $giftcards[$key]["id_customization"];

                $custom = Db::getInstance()->executeS($q);
                if ($custom) {
                    $giftcards[$key]['custom'] = $custom;
                }
            }
        }

    }
     
    return $giftcards;
}



function sendEmailGiftCard($value) {

    if ((int) Configuration::get('KERAWEN_CUST_SEND_GIFTCARD')) {

        require_once(_KERAWEN_CLASS_DIR_.'/data.php');
        
        $where = is_numeric($value) ? 'o.id_order = ' . (int) $value : 'o.reference = "'.pSQL($value).'"';

        $order =  Db::getInstance()->getRow('
            SELECT
                o.id_order, 
                o.id_lang, 
                o.id_shop, 
                o.id_cart,
                c.firstname,
                c.lastname,
                IFNULL(c.email, "") AS email,
                IFNULL(c.id_customer, 0) AS id_customer,
                IFNULL(ck.fakemail, 0) AS fakemail
            FROM '._DB_PREFIX_.'orders o
            /*LEFT JOIN '._DB_PREFIX_.'order_kerawen ok ON o.id_order = ok.id_order*/
            LEFT JOIN '._DB_PREFIX_.'customer c ON c.id_customer = o.id_customer
            LEFT JOIN '._DB_PREFIX_.'customer_kerawen ck ON c.id_customer = ck.id_customer
            WHERE ' . $where
        );
        

        if ($order) {
            if (isAnonymousCustomer($order['id_customer']) === false && (int) $order['fakemail'] == 0 && $order['email'] != '') {
                $giftcards = getGiftCardData('id_order', $order['id_order']);
                if ($giftcards) {
                    
                    $tplStr = 'GiftCardPdf';
                    require_once(_KERAWEN_CLASS_DIR_ . '/HTMLTemplate' . $tplStr . '.php');
                    $pdf = new PDF($giftcards, $tplStr, Context::getContext()->smarty);
                    $attachment = $pdf->render(false);
                    $filename = $pdf->filename;
                    
                    setEMailGiftCard(
                        $order["id_lang"],
                        $order["id_shop"],
                        $order["firstname"],
                        $order["lastname"],
                        array($order["email"]),
                        $filename,
                        $attachment
                    );

                }
            }
        }
    }
}


function setEMailGiftCard($id_lang, $id_shop, $firstname, $lastname, $email, $filename, $attachment) {
 
    $link = new Link;
    
    $shop_url = $link->getPageLink('index', true, $id_lang, null, false, $id_shop);
    $shop_name = Configuration::get('PS_SHOP_NAME', null, null, $id_shop);
    
    $logo = '';
    if (Configuration::get('PS_LOGO_MAIL') !== false && file_exists(_PS_IMG_DIR_.Configuration::get('PS_LOGO_MAIL', null, null, $id_shop))) {
        $logo = _PS_IMG_DIR_ . Configuration::get('PS_LOGO_MAIL', null, null, $id_shop);
    } else {
        if (file_exists(_PS_IMG_DIR_ . Configuration::get('PS_LOGO', null, null, $id_shop))) {
            $logo = _PS_IMG_DIR_ . Configuration::get('PS_LOGO', null, null, $id_shop);
        }
    }
    
    $shop_address =
    Configuration::get('PS_SHOP_NAME', null, null, $id_shop) . ' - ' .
    Configuration::get('PS_SHOP_ADDR1', null, null, $id_shop) . ' - ' .
    Configuration::get('PS_SHOP_ADDR2', null, null, $id_shop) . ' - ' .
    Configuration::get('PS_SHOP_CODE', null, null, $id_shop) . ' ' . Configuration::get('PS_SHOP_CITY', null, null, $id_shop) . ' - ' .
    Country::getNameById(Configuration::get('PS_LANG_DEFAULT', null, null, $id_shop), Configuration::get('PS_SHOP_COUNTRY_ID', null, null, $id_shop));
    
    $dataMail = array(
        '{shop_name}' => $shop_name,
        '{shop_url}' => $shop_url,
        '{shop_email}' => Configuration::get('PS_SHOP_EMAIL', null, null, $id_shop),
        '{shop_logo}' => $logo,
        '{name_to}' => $firstname . ' ' . $lastname,
        '{shop_link}' => '<a href="' . $shop_url . '">' . $shop_name . '</a>',
        '{shop_address}' => $shop_address,
    );
    
    $context = Context::getContext();
    $ps_mail_method = (isset($context->kerawen->PS_MAIL_METHOD) && (int) $context->kerawen->PS_MAIL_METHOD > 0) ? $context->kerawen->PS_MAIL_METHOD : Configuration::get('PS_MAIL_METHOD');
    $ps_mail_method_active = Configuration::get('PS_MAIL_METHOD');
    
    //Used original method
    Configuration::set('PS_MAIL_METHOD', $ps_mail_method);

    foreach ($email as $key => $itemEmail){
        Mail::Send(
            $id_lang,
            'custgiftcard',
            $shop_name . " - Carte cadeau ",
            $dataMail,
            $itemEmail,
            NULL,
            Configuration::get('PS_SHOP_EMAIL', null, null, $id_shop),
            Configuration::get('PS_SHOP_NAME', null, null, $id_shop),
            array(
                'content' => $attachment,
                'mime' => 'application/pdf',
                'name' => $filename
            ),
            NULL,
            _KERAWEN_DIR_ . '/mails/'
        );    
    }
    
    //Restore
    Configuration::set('PS_MAIL_METHOD', $ps_mail_method_active);
    
}
