<?php
/**
* 2014 KerAwen
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/AFL-3.0
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to contact@kerawen.com so we can send you a copy immediately.
*
* @author    KerAwen <contact@kerawen.com>
* @copyright 2014 KerAwen
* @license   http://opensource.org/licenses/AFL-3.0 Academic Free License (AFL 3.0)
*/

require_once(_KERAWEN_TOOLS_DIR_.'/utils.php');

function getNotif()
{
	$db = Db::getInstance();

    $context = Context::getContext();

    $new_orders = 0;
    
    $notif_till = json_decode(Configuration::get('KERAWEN_NOTIF_TILL'), true);
    $list_notif = array();
    foreach($notif_till as $notif) {
        if ((int) $notif['active'] == 1) {
            $list_notif[] = (int) $notif['id'];
        }
    }
    
    if (count($list_notif)) {

        $query_shops = '';
        if (isset($context->permissions)) {
            $shops = $context->permissions->ordersDisplay->id_shop;
            if ($shops) {
                $query_shops = ' AND id_shop IN (' . dataListToIntList($shops) . ') ';
            }
        }

        //TODO: include till modes as well
    	$new_orders = (int) $db->getValue('
    		SELECT 
                COUNT(*)
    		FROM '._DB_PREFIX_.'orders
    		WHERE current_state IN (' . implode(',', $list_notif) . ') ' . $query_shops
    	);
    }

	return array(
		'orders' => $new_orders,
		'messages' => 0
	);
}

function resetNotifOrders($context)
{
	Db::getInstance()->execute('
		UPDATE `'._DB_PREFIX_.'employee`
		SET `id_last_order` = (SELECT IFNULL(MAX(`id_order`), 0) FROM `'._DB_PREFIX_.'orders`)
		WHERE `id_employee` = '.(int) $context->employee->id);
}
