<?php
/**
* 2017 KerAwen
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/AFL-3.0
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to contact@kerawen.com so we can send you a copy immediately.
*
* @author    KerAwen <contact@kerawen.com>
* @copyright 2014 KerAwen
* @license   http://opensource.org/licenses/AFL-3.0 Academic Free License (AFL 3.0)
*/

require_once (dirname(__FILE__).'/KerawenAdminController.php');
require_once(_KERAWEN_CLASS_DIR_.'/invoice.php');
require_once(_KERAWEN_CLASS_DIR_.'/data.php');

class KerawenPurchaseOrderController extends KerawenAdminController
{
    public function __construct($params = false)
	{		

	    if ($params) {
	        $id_order = $params->id_order;
	        $action = 'send';
	    } else {
	        $id_order = (int) Tools::getValue('id_order');
	        $action = Tools::getValue('act');
	    }
	    
	    $tplStr = 'PurchaseOrderPdf';

	    $orderInvoice = new OrderInvoice();
	    $order = new Order($id_order);
	    $invoice_number = $order->invoice_number;
	    
	    $orderInvoice->id_order = $order->id;
	    $orderInvoice->total_discount_tax_excl = $order->total_discounts_tax_excl;
	    $orderInvoice->total_discount_tax_incl = $order->total_discounts_tax_incl;
	    $orderInvoice->total_paid_tax_excl = $order->total_paid_tax_excl;
	    $orderInvoice->total_paid_tax_incl = $order->total_paid_tax_incl;
	    $orderInvoice->total_products = $order->total_products;
	    $orderInvoice->total_products_wt = $order->total_products_wt;
	    $orderInvoice->total_shipping_tax_excl = $order->total_shipping_tax_excl;
	    $orderInvoice->total_shipping_tax_incl = $order->total_shipping_tax_incl;
	    $orderInvoice->total_wrapping_tax_excl = $order->total_wrapping_tax_excl;
	    $orderInvoice->total_wrapping_tax_incl = $order->total_wrapping_tax_incl;

	    //custom data
	    $orderInvoice->payments = OrderPayment::getByOrderReference($order->reference);
	    

	    require_once(_KERAWEN_CLASS_DIR_ . '/HTMLTemplate' . $tplStr . '.php');
	    $pdf = new PDF($orderInvoice, $tplStr, Context::getContext()->smarty);
	    $attachment = $pdf->render($action == 'download');

	    if ($action == 'send' && $attachment) {
	         if (!isAnonymousCustomer($order->id_customer)) {
	             $cust = new Customer($order->id_customer);
    	         setEMailInvoice(
    	             $order->id_lang,
    	             $order->id_shop,
    	             $cust->firstname,
    	             $cust->lastname,
    	             $cust->email,
    	             $filename = $pdf->filename,
    	             $attachment,
    	             'purchase'
    	         );    	         
	         }
	    }

	}
	
}



