<?php
/**
* 2018 KerAwen
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/AFL-3.0
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to contact@kerawen.com so we can send you a copy immediately.
*
* @author    KerAwen <contact@kerawen.com>
* @copyright 2018 KerAwen
* @license   http://opensource.org/licenses/AFL-3.0 Academic Free License (AFL 3.0)
*/

class KerawenPay_AccountModuleFrontController extends ModuleFrontController
{
	public $display_column_left = false;
	
	public function postProcess() {
		$customer = new Customer((int)$this->context->cart->id_customer);
		$total = $this->context->cart->getOrderTotal(true, Cart::BOTH);
		$accepted = false;
		
		require_once (_KERAWEN_CLASS_DIR_.'/customer.php');
		$account = getCustomerAccount($customer->id);
		if ($account) {
			$future = $account['amount'] - $total;
			$accepted = $future >= $account['limit'];
		}

		if ($accepted) {
			// Validate order and register payment
			$state = Configuration::get('PS_OS_PAYMENT');
			$this->module->validateOrder((int)$this->context->cart->id, $state,
				$total, $this->module->l('Customer account', 'pay_account'),
				null, array(),
				null, false,
				$customer->secure_key);
			adjustCustomerAccount($customer->id, -$total);
			
			Tools::redirectLink(__PS_BASE_URI__.'order-confirmation.php'
				.'?key='.$customer->secure_key
				.'&id_cart='.(int)$this->context->cart->id
				.'&id_module='.(int)$this->module->id
				.'&id_order='.(int)$order->id);
		}
		else {
			$this->context->smarty->assign(array(
				'kerawen' => array(
					'available' => $account,
					'current' => $account ? Tools::displayPrice($account['amount']) : null,
					'future' => $account ? Tools::displayPrice($future) : null,
					'limit' => $account ? Tools::displayPrice($account['limit']) : null,
				)));
			$this->setTemplate('account_refused.tpl');
		}
	}
}
