{extends file='customer/page.tpl'}

{block name='page_title'}
  {l s='Quotes' mod='kerawen'}
{/block}

{block name='page_content'}

<h6>{l s='Your quotations' mod='kerawen'}</h6>

<div class="content">
	<div>
	
				{if $quotes && count($quotes)}
    			<table class="table table-striped table-bordered table-labeled hidden-sm-down">
      				<thead class="thead-default">
                        <tr>
                            <th class="item">{l s='Id' mod='kerawen'}</th>
                            <th class="item">{l s='Expiry date' mod='kerawen'}</th>
                            <th class="item">{l s='Total' mod='kerawen'}</th>
                            <th class="item">&nbsp;</th>
                            <th class="item">&nbsp;</th>
                        </tr>
                    </thead>
                    <tbody>
                    {foreach from=$quotes item=quote name=myLoop}
                        <tr class="">
                            <td>{$quote.quote_title|escape:'htmlall':'UTF-8'}</td>
                            <td>{dateFormat date=$quote.quote_expiry full=0}</td>
                            <td>{$quote.total}</td>
                            <td><a href="{url entity='module' name='kerawen' controller='quotenext' params = ['id_cart'=>$quote.id_cart, 'action'=>'download']}">{l s='Download' mod='kerawen'} <i class="material-icons">&#xE415;</i></a></td>
                            <td class="text-xs-right">{if $quote.quote_active == 1}<a href="{url entity='module' name='kerawen' controller='quotenext' params = ['id_cart'=>$quote.id_cart, 'action'=>'display']}">{l s='Order now' mod='kerawen'}{else}{l s='Expired' mod='kerawen'}{/if}</a></td>
                        </tr>
                    {/foreach}
                    </tbody>
				</table>
				
				<div class="orders hidden-md-up">
					{foreach from=$quotes item=quote name=myLoop}
					<div class="order">
						<div class="row">
							<div class="col-xs-10">
             					 {if $quote.quote_active == 1}<a href="{url entity='module' name='kerawen' controller='quotenext' params = ['id_cart'=>$quote.id_cart, 'action'=>'display']}"><h3>{$quote.quote_title|escape:'htmlall':'UTF-8'}</h3></a>{else}<h3>{$quote.quote_title|escape:'htmlall':'UTF-8'}</h3>{/if}
              					 <div class="date">{dateFormat date=$quote.quote_expiry full=0}</div>
              					 <div class="total">{$quote.total}</div>
              					 {if $quote.quote_active != 1}
              					 <div class="status">
                					<span class="label label-pill" style="background-color:#f33">{l s='Expired' mod='kerawen'}</span>
              					 </div>
              					 {/if}
            				</div>
							<div class="col-xs-2 text-xs-right">
                				<div>
                  					<a href="{url entity='module' name='kerawen' controller='quotenext' params = ['id_cart'=>$quote.id_cart, 'action'=>'download']}" data-link-action="view-quote-details" title="{l s='Download' mod='kerawen'}">
                    					<i class="material-icons">&#xE8B6;</i>
                  					</a>
                				</div>
                				{if $quote.quote_active == 1}
                                <div>
                    				<a href="{url entity='module' name='kerawen' controller='quotenext' params = ['id_cart'=>$quote.id_cart, 'action'=>'display']}" title="{l s='Order now' mod='kerawen'}">
                      					<i class="material-icons">&#xE863;</i>
                    				</a>
                 				 </div>
                 				{/if}
                            </div>
						</div>
					</div>
					{/foreach}
				</div>
				
				{else}
					<p class="warning">{l s='No quotes found' mod='kerawen'}</p>
				{/if}

				<!--div>Pour les units : voir controller/front/DiscountController.php</div-->

	</div>
</div>


{/block}